unit rOrders;

interface

uses
  System.SysUtils, System.Classes, frxClass, frxDBSet,
  frxExportBaseDialog, frxExportPDF, frCoreClasses, Uni, Data.DB,
  XData.Service.Common, Aurelius.Mapping.Attributes, System.JSON, System.Generics.Collections;

type
  TrptOrders = class(TDataModule)
    frxReport: TfrxReport;
    frxPDFExport: TfrxPDFExport;
    frxDBDataset: TfrxDBDataset;
    DataSource: TDataSource;
    UniQuery: TUniQuery;
    frxReport1: TfrxReport;
    frxPDFExport1: TfrxPDFExport;
  private
    { Private declarations }
  public
    { Public declarations }
    procedure PrepareReport(OrderID: string);
  end;

var
  rptOrders: TrptOrders;

implementation

{%CLASSGROUP 'Vcl.Controls.TControl'}

{$R *.dfm}

{ TrptOrders }

procedure TrptOrders.PrepareReport(OrderID: string);
var
  SQL: string;
begin
  try
    // 1. **Prepare the Query**
    SQL := 'SELECT * FROM orders WHERE ORDER_ID = :OrderID';
    UniQuery.Close;
    UniQuery.SQL.Text := SQL;
    UniQuery.ParamByName('OrderID').AsString := OrderID;
    UniQuery.Open;

    // 2. **Connect the Query to the Report**
    frxDBDataset.DataSet := UniQuery;

    // 3. **Set Report Variables (if needed)**
    frxReport.Variables['OrderID'] := QuotedStr(OrderID);

    // 4. **Prepare the Report**
    frxReport.PrepareReport(True);
  except
    on E: Exception do
      raise Exception.Create('Error preparing the report: ' + E.Message);
  end;
end;

end.

